<?php
/*
Plugin Name: Gravity Forms Category Selector Add-On
Description: Allows Category Selectors on Gravity Form
Version: 0.0.9
Author: Nikolaos Anastopoulos

------------------------------------------------------------------------
Copyright 2009 Nikolaos Anastopoulos

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

add_action('gform_field_standard_settings', 'custom_gform_field_standard_settings', 10, 2);
function custom_gform_field_standard_settings($position, $form_id) {
    if ($position == 850) { ?>
		<li class="post_category_field_type_setting field_setting">
			<label for="post_category_field_type">
				<?php _e("Field Type", "gravityforms"); ?>
				<?php gform_tooltip("form_field_type") ?>
			</label>
			<select id="post_category_field_type" onchange="if(jQuery(this).val() == '') return; jQuery('#field_settings').slideUp(function(){StartChangeInputType(jQuery('#post_category_field_type').val());});">
				<option value="select"><?php _e("Drop Down", "gravityforms"); ?></option>
				<option value="multiselect"><?php _e("Multi Select", "gravityforms"); ?></option>
				<option value="checkbox"><?php _e("Checkboxes", "gravityforms"); ?></option>
				<option value="radio"><?php _e("Radio Buttons", "gravityforms"); ?></option>
			</select>
		</li>
    <?php }
}

add_action('gform_editor_js', 'custom_gform_editor_js');
function custom_gform_editor_js() { ?>
    <script type="text/javascript">
        jQuery(document).bind('gform_load_field_settings', function(event, field, form) {
            if (field['type'] == 'post_category') {
                jQuery('.post_category_field_type_setting').show();
                jQuery('.choices_setting').hide();
            } else {
                jQuery('.post_category_field_type_setting').hide();
            }

            jQuery('#post_category_field_type').val(field['inputType']);
        });
    </script>
<?php }

add_action('gform_post_submission', 'custom_gform_post_submission', 10, 2);
function custom_gform_post_submission($entry, $form) {
    if (!$entry['post_id']) return;

	wp_set_object_terms($entry['post_id'], NULL, 'category');

    foreach ($form['fields'] as $field) {
        if ($field['type'] != 'post_category') continue;

        if ($field['inputType'] == 'checkbox')
			foreach ($_POST as $key => $value) {
				if (strpos($key, "input_{$field['id']}_") !== false)
					wp_set_object_terms($entry['post_id'], intval($value), 'category', true);
			}
        elseif ($field['inputType'] == 'multiselect')
			foreach ($_POST as $key => $values) {
				if (strpos($key, "input_{$field['id']}") !== false)
					foreach ($values as $value)
						wp_set_object_terms($entry['post_id'], intval($value), 'category', true);
			}
        else
			wp_set_object_terms($entry['post_id'], intval($entry[$field['id']]), 'category', true);
	}
}
?>
